//
//  Rs[^OtBbNX_II
//  e̕`̃TvvO
//

// Windows wb_t@C̃CN[h
#include <windows.h>

// GLUTwb_t@C̃CN[h
#include <GL/glut.h>

// wb_t@C̃CN[h
#include "Obj.h"
#include "bitmap.h"


// _̂߂̃O[oϐ

// EBhẼTCY
int  win_width, win_height;

// J̉]̂߂̕ϐ
float   camera_yaw = 15.0f; // 30.0;     // x𒆐SƂ]px
float   camera_pitch = -20.0f; // -30.0;   // w𒆐SƂ]px
float   camera_distance = 15.0; // SJ̋

// }EX̃hbÔ߂̕ϐ
int  drag_mouse_r = 0; // E{^hbOǂ̃tOi1:hbO, 0:hbOj
int  drag_mouse_l = 0; // {^hbOǂ̃tOi1:hbO, 0:hbOj
int  drag_mouse_m = 0; // {^hbOǂ̃tOi1:hbO, 0:hbOj
int  last_mouse_x, last_mouse_y; // ŌɋL^ꂽ}EXJ[\̍W

// ̂̉]Aj[V̂߂̕ϐ
bool    on_animation = true;


// e̕`ɊւO[oϐ

// e̕`@
enum  ShadowModeEnum
{
	SHADOW_NONE,
	SHADOW_TEXTURE,
	SHADOW_PROJECTION,
	SHADOW_VOLUME,
	NUM_SHADOW_MODE
};

// ݂̉e̕`@
ShadowModeEnum    shadow_mode = SHADOW_TEXTURE; // SHADOW_PROJECTION;

// e̕`@̖O
const char *  shadow_mode_name[ NUM_SHADOW_MODE ] = {
	"No Shadow", "Texture Shadow", "Polygon Projection Shadow", "Shadow Volume" };

// _̈ʒuie̓ej
Vector    light_pos;

// ẽeNX`摜̔ԍ
unsigned int    shadow_texture = 0;

// |Seɂe̕`F
float    shadow_color_rgb = 0.2f;
float    shadow_color_alpha = 0.5f;

// e̕`̐ݒiufBOXeVobt@̎gp̗L̐؂ւj
bool    shadow_blend_off = false;
bool    shadow_stencil_off = false;


// 􉽌`IuWFNgɊւO[oϐ

// 􉽌`IuWFNg̐
#define  NUM_OBJECTS  2

// 􉽌`IuWFNg
Obj *     object[ NUM_OBJECTS ] = { NULL, NULL };

// ʒu
Vector    object_pos[ NUM_OBJECTS];

// 
float     object_ori[ NUM_OBJECTS ];

// 傫ieNX`}bsOɂe̕`pj
Vector    object_size[ NUM_OBJECTS ];

// `tO
bool      object_display[ NUM_OBJECTS ] = { true, true };

// Aj[VtO
bool      object_animation[ NUM_OBJECTS ] = { false, true };



///////////////////////////////////////////////////////////////////////////////
//
//  eNX`}bsOɂe̕`
//


//
//  ẽeNX`摜̓ǂݍ݁Eݒ
//
bool  LoadShadowTexture( const char * filename = NULL )
{
	// ftHg̃eNX`摜̃t@C
	static const char *  default_filename = "shadow.bmp";

	// ǂݍ݂Ɏsǂ̃tO
	static bool  try_default_file = false;

	// t@CȗꂽftHg̉摜t@Cgp
	if ( filename == NULL )
	{
		// ɃftHg̉摜t@C̓ǂݍ݂ɎsĂΏI
		if ( try_default_file )
			return  false;

		// ftHg̉摜t@Cݒ
		filename = default_filename;
	}

	// eNX`摜̓ǂݍ
	int  result;
	unsigned char *  shadow_image = NULL;
	int  shadow_width, shadow_height;
	result = loadBitmap( filename, &shadow_image, &shadow_width, &shadow_height );

	// ǂݍ݂ɎsI
	if ( result != 0 )
	{
		if ( filename == default_filename )
			try_default_file = true;
		return  false;
	}

	// eNX`}bsO̐ݒ
	glGenTextures( 1, &shadow_texture );
	glBindTexture( GL_TEXTURE_2D, shadow_texture );
	glTexImage2D( GL_TEXTURE_2D, 0, GL_RGB, shadow_width, shadow_height, 0, 
				GL_RGB, GL_UNSIGNED_BYTE, shadow_image );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );

	return  true;
}


//
//  eNX`}bsOɂe̕`
//
void  RenderTextureShadow( float obj_matrix[ 16 ], float size_x, float size_z, float shadow_y )
{
	// eNX`摜̓ǂݍ݂Ɛݒ
	// eNX`摜ǂݍ܂ĂȂ΁AŏɃftHg̉摜ǂݍ
	if ( shadow_texture == 0 )
	{
		// ǂݍ݂ɎsI
		if ( ! LoadShadowTexture() )
			return;
	}

	// ẽeNX`摜`悷l̐ʒu{
	float  x0, z0, x1, z1, x2, z2, x3, z3, y;

	// |[gۑ


	// ݂̕`ݒ擾i`IɌ̐ݒɖ߂߁j
	GLboolean  b_texture, b_blend, b_lighting;
	glGetBooleanv( GL_TEXTURE_2D, &b_texture );
	glGetBooleanv( GL_BLEND, &b_blend );
	glGetBooleanv( GL_LIGHTING, &b_lighting );

	// `ݒ̕ύX
	glDisable( GL_LIGHTING );
	glEnable( GL_BLEND );
	glEnable( GL_TEXTURE_2D );

	// mF̂߂̕`ݒ̕ύX
	if ( shadow_blend_off )
		glDisable( GL_BLEND );

	// eNX`}bsO̐ݒ
	glBindTexture( GL_TEXTURE_2D, shadow_texture );
	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL );

	// |[gۑ


	// `ݒ𕜌
	if ( b_lighting )
		glEnable( GL_LIGHTING );
	if ( !b_blend )
		glDisable( GL_BLEND );
	if ( !b_texture )
		glDisable( GL_TEXTURE_2D );
}



///////////////////////////////////////////////////////////////////////////////
//
//  |Seɂe̕`
//


//
//  􉽌`󃂃fiObj`j̕`iŒFŕ`j
//
void  RenderObjUnicolor( const Obj * obj, float color_r, float color_g, float color_b, float color_a )
{
	// |[gۑ


}


//
//  |Seɂe̕`
//
void  RenderProjectionShadow( const Obj * obj, const float obj_matrix[ 16 ], const Vector & light_dir, float color_r, float color_g, float color_b, float color_a )
{
	// ݂̕`ݒ擾i`IɌ̐ݒɖ߂߁j
	GLboolean  b_cull_face, b_blend, b_lighting, b_stencil;
	glGetBooleanv( GL_CULL_FACE, &b_cull_face );
	glGetBooleanv( GL_BLEND, &b_blend );
	glGetBooleanv( GL_LIGHTING, &b_lighting );
	glGetBooleanv( GL_STENCIL_TEST, &b_stencil );

	// `ݒ̕ύX
	if ( b_lighting )
		glDisable( GL_LIGHTING );
	if ( !b_cull_face )
		glEnable( GL_CULL_FACE );
	if ( !b_blend )
		glEnable( GL_BLEND );

	// ufBO̐ݒ
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );

	// XeVobt@̐ݒ

	// |[gۑ


	// mF̂߂̕`ݒ̕ύX
	if ( shadow_blend_off )
		glDisable( GL_BLEND );
	if ( shadow_stencil_off )
		glDisable( GL_STENCIL_TEST );


	// ݂̕ϊsꎞۑ
	glPushMatrix();

	// |Sfnʂɓeĕ`悷邽߂̕ϊsݒ
	//i̎_ŁA[hWnJWnւ̕ϊs񂪐ݒ肳Ă̂Ƃj

	// |[gۑ


	// e̕`A􉽌`󃂃fwFŕ`
	RenderObjUnicolor( obj, color_r, color_g, color_b, color_a );

	// ꎞۑĂϊs𕜌
	glPopMatrix();

	// `ݒ𕜌
	if ( b_lighting )
		glEnable( GL_LIGHTING );
	if ( b_cull_face )
		glEnable( GL_CULL_FACE );
	if ( !b_blend )
		glDisable( GL_BLEND );
	if ( !b_stencil )
		glDisable( GL_STENCIL_TEST );
}



///////////////////////////////////////////////////////////////////////////////
//
//  VhEEH[ɂe̕`
//


//
//  VhEEH[`
//
void  DrawShadowVolume( const Obj * obj, const float model_world[ 16 ], const Vector & light_vec )
{
	// ȗ
}

//
//  VhEEH[hԂ
//
void  FillShadowVolume( float color_r, float color_g, float color_b, float color_a )
{
	// ȗ
}



///////////////////////////////////////////////////////////////////////////////
//
//  ȉAvÕC
//


//
//  􉽌`IuWFNg̓ǂݍ݁E
//
void  InitObjects()
{
	// 􉽌`IuWFNg̓ǂݍ
	if ( !object[ 0 ] )
	{
		object[ 0 ] = LoadObj( "Car.obj" );
		if ( object[ 0 ] )
		{
			ScaleObj( object[ 0 ], 5.0f, &object_size[ 0 ].x, &object_size[ 0 ].y, &object_size[ 0 ].z );
			object_size[ 0 ].x *= 1.5;
			object_size[ 0 ].z *= 1.5;
		}
	}
	if ( !object[ 1 ] )
	{
		object[ 1 ] = LoadObj( "Pyramid.obj" );
		if ( object[ 1 ] )
		{
			ScaleObj( object[ 1 ], 2.0f, &object_size[ 1 ].x, &object_size[ 1 ].y, &object_size[ 1 ].z );
			object_size[ 1 ].x *= 1.5;
			object_size[ 1 ].z *= 1.5;
		}
	}

	// 􉽌`IuWFNg̏ʒuE̐ݒ
	object_pos[ 0 ].x = 0.0f;
	object_pos[ 0 ].y = 2.0f;
	object_pos[ 0 ].z = 0.0f;
	object_ori[ 0 ] = 180.0f;

	object_pos[ 1 ].x = 2.5f;
	object_pos[ 1 ].y = 4.0f;
	object_pos[ 1 ].z = 1.5f;
	object_ori[ 1 ] = 0.0f;
}


//
//  iq͗l̏`
//
void  DrawFloor( float tile_size, int num_x, int num_z, float r0, float g0, float b0, float r1, float g1, float b1 )
{
	int  x, z;
	float  ox, oz;

	glBegin( GL_QUADS );
	glNormal3d( 0.0, 1.0, 0.0 );

	ox = - ( num_x * tile_size ) / 2;
	for ( x=0; x<num_x; x++ )
	{
		oz = - ( num_z * tile_size ) / 2;
		for ( z=0; z<num_z; z++ )
		{
			if ( ( (x + z) % 2 ) == 0 )
				glColor3f( r0, g0, b0 );
			else
				glColor3f( r1, g1, b1 );

			glTexCoord2d( 0.0f, 0.0f );
			glVertex3d( ox, 0.0, oz );
			glTexCoord2d( 0.0f, 1.0f );
			glVertex3d( ox, 0.0, oz + tile_size );
			glTexCoord2d( 1.0f, 1.0f );
			glVertex3d( ox + tile_size, 0.0, oz + tile_size );
			glTexCoord2d( 1.0f, 0.0f );
			glVertex3d( ox + tile_size, 0.0, oz );

			oz += tile_size;
		}
		ox += tile_size;
	}
	glEnd();
}


//
//  ĩ݂[hj`
//
void  DrawTextInformation( const char * message )
{
	// \郁bZ[W
	int   i;

	// ˉesȋOɌ݂̍sޔj
	glMatrixMode( GL_PROJECTION );
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D( 0.0, win_width, win_height, 0.0 );

	// fr[sȋOɌ݂̍sޔj
	glMatrixMode( GL_MODELVIEW );
	glPushMatrix();
	glLoadIdentity();

	// yobt@ECeBO̓Itɂ
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_LIGHTING );

	// bZ[W̕`
	glColor3f( 1.0, 0.0, 0.0 );
	glRasterPos2i( 16, 16 + 18 );
	for ( i=0; message[i]!='\0'; i++ )
		glutBitmapCharacter( GLUT_BITMAP_HELVETICA_18, message[i] );

	// ݒSĕ
	glEnable( GL_DEPTH_TEST );
	glEnable( GL_LIGHTING );
	glMatrixMode( GL_PROJECTION );
	glPopMatrix();
	glMatrixMode( GL_MODELVIEW );
	glPopMatrix();
}


//
//  ʕ`掞ɌĂ΂R[obN֐
//
void  DisplayCallback()
{
	// ʂNAisNZf[^Ƃyobt@̗NAj
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT );
	
	// _p^ɉĕϊsiJWn烏[hWnւ̕ϊsjݒ
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	glTranslatef( 0.0,  0.0, - camera_distance );
	glRotatef( - camera_pitch, 1.0, 0.0, 0.0 );
	glRotatef( - camera_yaw, 0.0, 1.0, 0.0 );

	// ʒuݒ
	float  light0_position[] = { light_pos.x, light_pos.y, light_pos.z, 1.0 };
	glLightfv( GL_LIGHT0, GL_POSITION, light0_position );

	// iq͗l̏`
	DrawFloor( 1.5f, 10, 10, 1.0, 1.0, 1.0, 1.0, 0.8, 0.8 );

	// ꂼ̊􉽌`󃂃f{e`
	for ( int i=0; i<NUM_OBJECTS; i++ )
	{
		if ( ! object[ i ] )
			continue;
		if ( ! object_display[ i ] )
			continue;

		// fWn烏[hWnւ̕ϊsvZ
		float  matrix[ 16 ];

		// ϊsvZ邽߂ɁA݂̕ϊsꎞۑ
		glPushMatrix();

			// ϊsPʍsŏ
			glLoadIdentity();

			// f̈ʒuE̕ϊs
			glTranslatef( object_pos[ i ].x, object_pos[ i ].y, object_pos[ i ].z );
			glRotatef( object_ori[ i ], 0.0f, 1.0f, 0.0f );

			// ϊs擾ifWn烏[hWnւ̕ϊsj
			glGetFloatv( GL_MODELVIEW_MATRIX, matrix );

		// ꎞۑĂϊs𕜌
		glPopMatrix();


		glPushMatrix();

			// ݂̕ϊsɁAfWn烏[hWnւ̕ϊs
			glMultMatrixf( matrix );

			// IuWFNg`
			RenderObj( object[ i ] );

		glPopMatrix();

		// e`
		if ( shadow_mode == SHADOW_PROJECTION )
		{
			// |Seɂe̕`
			RenderProjectionShadow( object[ i ], matrix, light_pos, shadow_color_rgb, shadow_color_rgb, shadow_color_rgb, shadow_color_alpha );
		}
		else if ( shadow_mode == SHADOW_TEXTURE )
		{
			// eeNX``悷鍂inʂ⑼̉eƏdȂȂ悤ɔɍωj
			float  height = 0.01f * ( i + 1 );

			// eNX`}bsOɂe̕`
			RenderTextureShadow( matrix, object_size[ i ].x, object_size[ i ].z, height );
		}
		else if ( shadow_mode == SHADOW_VOLUME )
		{
			// Pڂ̃IuWFNǵA|Seɂe̕`
			if ( i == 0 )
				RenderProjectionShadow( object[ i ], matrix, light_pos, shadow_color_rgb, shadow_color_rgb, shadow_color_rgb, shadow_color_alpha );
			else
			// Qڂ̃IuWFNǵAVhEEH[ɂe̕`
			{
				DrawShadowVolume( object[ i ], matrix, light_pos );
				FillShadowVolume( shadow_color_rgb, shadow_color_rgb, shadow_color_rgb, shadow_color_alpha );
			}

		}
	}

	// ĩ݂[hj`
	DrawTextInformation( shadow_mode_name[ shadow_mode ] );

	// obNobt@ɕ`悵ʂtgobt@ɕ\
	glutSwapBuffers();
}


//
//  EBhETCYύXɌĂ΂R[obN֐
//
void  ReshapeCallback( int w, int h )
{
	// EBhE̕`s͈͂ݒił̓EBhEŜɕ`j
	glViewport(0, 0, w, h);
	
	// JWnXN[Wnւ̕ϊsݒ
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	gluPerspective( 45, (double)w/h, 1, 500 );

	// EBhẼTCYL^ieLXg`揈̂߁j
	win_width = w;
	win_height = h;
}


//
// }EXNbNɌĂ΂R[obN֐
//
void  MouseClickCallback( int button, int state, int mx, int my )
{
	// E{^ꂽhbOJn
	if ( ( button == GLUT_RIGHT_BUTTON ) && ( state == GLUT_DOWN ) )
		drag_mouse_r = 1;
	// E{^ꂽhbOI
	else if ( ( button == GLUT_RIGHT_BUTTON ) && ( state == GLUT_UP ) )
		drag_mouse_r = 0;

	// {^ꂽhbOJn
	if ( ( button == GLUT_LEFT_BUTTON ) && ( state == GLUT_DOWN ) )
		drag_mouse_l = 1;
	// {^ꂽhbOI
	else if ( ( button == GLUT_LEFT_BUTTON ) && ( state == GLUT_UP ) )
		drag_mouse_l = 0;

	// {^ꂽhbOJn
	if ( ( button == GLUT_MIDDLE_BUTTON ) && ( state == GLUT_DOWN ) )
		drag_mouse_m = 1;
	// {^ꂽhbOI
	else if ( ( button == GLUT_MIDDLE_BUTTON ) && ( state == GLUT_UP ) )
		drag_mouse_m = 0;

	// ݂̃}EXWL^
	last_mouse_x = mx;
	last_mouse_y = my;
}


//
// }EXhbOɌĂ΂R[obN֐
//
void  MouseDragCallback( int mx, int my )
{
	// E{^̃hbO͎_]
	if ( drag_mouse_r && !( glutGetModifiers() & GLUT_ACTIVE_CTRL ) )
	{
		// Õ}EXWƍ̃}EXW̍ɉĎ_]

		// }EX̉ړɉĂx𒆐Sɉ]
		camera_yaw -= ( mx - last_mouse_x ) * 1.0;
		if ( camera_yaw < 0.0 )
			camera_yaw += 360.0;
		else if ( camera_yaw > 360.0 )
			camera_yaw -= 360.0;

		// }EX̏cړɉĂw𒆐Sɉ]
		camera_pitch -= ( my - last_mouse_y ) * 1.0;
		if ( camera_pitch < -90.0 )
			camera_pitch = -90.0;
		else if ( camera_pitch > 90.0 )
			camera_pitch = 90.0;
	}

	// {^i ctrlL[ȂE{^j̃hbO͎_ƃJ̋ύX
	if ( drag_mouse_m || ( drag_mouse_r && ( glutGetModifiers() & GLUT_ACTIVE_CTRL ) ) )
	{
		// Õ}EXWƍ̃}EXW̍ɉĎ_]

		// }EX̏cړɉċړ
		camera_distance += ( my - last_mouse_y ) * 0.2;
		if ( camera_distance < 5.0 )
			camera_distance = 5.0;
	}

	// {^̃hbO͉e̕ύX
	if ( drag_mouse_l )
	{
		// Õ}EXWƍ̃}EXW̍ɉĉe̕ύX

		// }EX̏cړɉċړ
		float  delta_x = ( mx - last_mouse_x ) * 0.05f;
		float  delta_z = ( my - last_mouse_y ) * 0.05f;
		
		light_pos.x += delta_x;
		if ( light_pos.x < -5.0f )
			light_pos.x = -5.0f;
		else if ( light_pos.x > 5.0f )
			light_pos.x = 5.0f;

		light_pos.z += delta_z;
		if ( light_pos.z < -5.0f )
			light_pos.z = -5.0f;
		else if ( light_pos.z > 5.0f )
			light_pos.z = 5.0f;
	}

	// ̃}EXWL^
	last_mouse_x = mx;
	last_mouse_y = my;

	// ĕ`̎woǐōĕ`̃R[obN֐Ă΂j
	glutPostRedisplay();
}


//
//  L[{[h̃L[ꂽƂɌĂ΂R[obN֐
//
void  KeyboardCallback( unsigned char key, int mx, int my )
{
	// mL[ŉe̕`惂[hύX
	if ( key == 'm' )
	{
		shadow_mode = (ShadowModeEnum)( ( shadow_mode + 1 ) % NUM_SHADOW_MODE );
		glutPostRedisplay();
	}

	// oL[ŃIuWFNg̕`ύX
	if ( key == 'o' )
	{
		if ( object_display[ 0 ] && object_display[ 1 ] )
		{
			object_display[ 0 ] = false;
		}
		else if ( !object_display[ 0 ] && object_display[ 1 ] )
		{
			object_display[ 0 ] = true;
			object_display[ 1 ] = false;
		}
		else
		{
			object_display[ 1 ] = true;
		}
	}

	// sL[ŃIuWFNg̃Aj[VύX
	if ( key == 's' )
	{
		if ( object_animation[ 0 ] && object_animation[ 1 ] )
		{
			object_animation[ 0 ] = false;
			object_animation[ 1 ] = false;
		}
		else if ( !object_animation[ 0 ] && object_animation[ 1 ] )
		{
			object_animation[ 0 ] = true;
			object_animation[ 1 ] = true;
		}
		else
		{
			object_animation[ 0 ] = false;
			object_animation[ 1 ] = true;
		}
		on_animation = ( object_animation[ 0 ] && object_animation[ 1 ] );
	}

	// dL[ŃfobO[hύX
	if ( key == 'd' )
	{
		if ( !shadow_blend_off && !shadow_stencil_off )
		{
			shadow_blend_off = true;
		}
		else if ( shadow_blend_off && !shadow_stencil_off )
		{
			shadow_blend_off = false;
			shadow_stencil_off = true;
		}
		else
		{
			shadow_blend_off = false;
			shadow_stencil_off = false;
		}
	}

	// ĕ`̎woǐōĕ`̃R[obN֐Ă΂j
	glutPostRedisplay();
}



//
//  AChɌĂ΂R[obN֐
//
void  IdleCallback( void )
{
	if ( on_animation )
	{
#ifdef  WIN32
		// VXeԂ擾AO񂩂̌oߎԂɉă
		static DWORD  last_time = 0;
		DWORD  curr_time = timeGetTime();
		float  delta = ( curr_time - last_time ) * 0.001f;
		if ( delta > 0.01f )
			delta = 0.01f;
		last_time = curr_time;
#else
		// Œ̃gp
		delta = 0.01f;
#endif
		// IuWFNg]
		for ( int i=0; i<NUM_OBJECTS; i++ )
		{
			if ( !object_animation[ i ] )
				continue;

			object_ori[ i ] += 100.0 * delta;
			if ( object_ori[ i ] > 360.0f )
				object_ori[ i ] -= 360.0f;
			if ( object_ori[ i ] < 0.0f )
				object_ori[ i ] += 360.0f;
		}

		// ĕ`̎woǐōĕ`̃R[obN֐Ă΂j
		glutPostRedisplay();
	}
}


//
//  ֐
//
void  InitEnvironment()
{
	// 쐬
	float  light0_position[] = { 10.0, 10.0, 10.0, 1.0 };
	float  light0_diffuse[] = { 0.8, 0.8, 0.8, 1.0 };
	float  light0_specular[] = { 1.0, 1.0, 1.0, 1.0 };
	float  light0_ambient[] = { 0.1, 0.1, 0.1, 1.0 };
	glLightfv( GL_LIGHT0, GL_POSITION, light0_position );
	glLightfv( GL_LIGHT0, GL_DIFFUSE, light0_diffuse );
	glLightfv( GL_LIGHT0, GL_SPECULAR, light0_specular );
	glLightfv( GL_LIGHT0, GL_AMBIENT, light0_ambient );
	glEnable( GL_LIGHT0 );

	// vZLɂ
	glEnable( GL_LIGHTING );

	// ̂̐FLɂ
	glEnable( GL_COLOR_MATERIAL );

	// yeXgLɂ
	glEnable( GL_DEPTH_TEST );

	// wʏLɂ
	glCullFace( GL_BACK );
	glEnable( GL_CULL_FACE );

	// wiFݒ
	glClearColor( 0.5, 0.5, 0.8, 0.0 );

	// ʒu
	light_pos.x = 4.0f;
	light_pos.y = 5.0f;
	light_pos.z = 1.0f;
}


//
//  C֐ivO͂Jnj
//
int  main( int argc, char ** argv )
{
	// GLUT̏
	glutInit( &argc, argv );
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA | GLUT_STENCIL );
	glutInitWindowSize( 640, 640 );
	glutInitWindowPosition( 0, 0 );
	glutCreateWindow("Shadow Sample");
	
	// R[obN֐̓o^
	glutDisplayFunc( DisplayCallback );
	glutReshapeFunc( ReshapeCallback );
	glutMouseFunc( MouseClickCallback );
	glutMotionFunc( MouseDragCallback );
	glutKeyboardFunc( KeyboardCallback );
	glutIdleFunc( IdleCallback );

	// 
	InitEnvironment();

	// IuWFNg̓ǂݍ݁E
	InitObjects();

	// GLUT̃C[vɏڂ
	glutMainLoop();
	return 0;
}

